;; CODI PER RESOLDRE L'EXERCICI DE CERCA DE LES BOMBETES
;; El codi que heu d'implementar est indicat al principi
;; i tamb ho teniu explicat a l'enunciat de l'exercici.
;;
;; La resta de codi no l'heu de tocar !!
;; Per tant no cal que us preocupeu de com estan imple-
;; mentades les funcions que us donem. Concretament teniu:
;; - Implementaci del A*
;; - Unes funcions extra que us poden servir per imple-
;; mentar l'operador "apagar". Useu-les si voleu.
;;
;; La crida principal s'ha de fer a la funci (A* ...)
;; passant-li l'estat inicial i l'estat final segons
;; la vostra forma de codificacio dels estats.
;;
;; Cada vegada que executeu A* s'escriura la traa de
;; l'execucio de l'algorisme en el fitxer "llums.log".
;; D'aquesta manera podeu saber quins operadors es van 
;; aplicant a cada pas i quins camins aneu obtenint.
;; -------------------------------------------------------

;;;;;;;;;;;;
;Alumne: Sergio Blanco Cuaresma
;;;;;;;;;;;;

;; Definir els 2 operadors:

; 1. Encendre la primera bombeta apagada seguida d'una encesa

(defun encendre (estat)
	(encendre* estat nil nil)
)

; Estat actual, ultima bombeta activa, resultat
(defun encendre* (estat anterior_apagada resultat)
	(if (null estat) resultat
		(if (= (car estat) 0) (encendre* (cdr estat) T (reverse (cons (car estat) (reverse resultat))) )
			; bombeta actual = 1
			(if anterior_apagada
				(progn
					(append (reverse (cons 1 (cdr (reverse resultat)))) estat)
				)
				(encendre* (cdr estat) nil (reverse (cons (car estat) (reverse resultat))) )
			)
		)
	)
)
			

; 2. Apagar totes les bombetes que estan entre 2 enceses

(defun apagar (estat)
	(apagar* estat (entre2 1 estat) 0 nil)
)

; estat actual, posicions de les bombetes a apagar, posicio actual dintre l'estat
; resultat
(defun apagar* (estat apagar pos resultat)
	(if (null estat) resultat
		(if (null apagar) (append resultat estat)
			(if (= (car apagar) pos)
				(apagar* (cdr estat) (cdr apagar) (+ pos 1) (reverse (cons 0 (reverse resultat))))
				(apagar* (cdr estat) apagar (+ pos 1) (reverse (cons (car estat) (reverse resultat))))
			)
		)
	)
)
	

;------------
;; Funcio heuristica per avaluar l'estat actual

(defun heuristica (estat_actual estat_final)
	(heuristica2 estat_actual estat_final 0)
)

; heuristica ms dolenta
(defun heuristica1 (estat_actual estat_final resultat)
	(if (null estat_actual) resultat
		(if (= (car estat_actual) (car estat_final))
			(heuristica1 (cdr estat_actual) (cdr estat_final) (+ resultat 1))
			(heuristica1 (cdr estat_actual) (cdr estat_final) (- resultat 1))
		)
	)
)

; heuristica ms bona
(defun heuristica2 (estat_actual estat_final resultat)
	(if (null estat_actual) resultat
		(if (= (car estat_actual) (car estat_final))
			(heuristica2 (cdr estat_actual) (cdr estat_final) (+ resultat 1))
			(heuristica2 (cdr estat_actual) (cdr estat_final) resultat )
		)
	)
)


;; --------------------------------------------------------
; CODI ADDICIONAL PER IMPLEMENTAR L'OPERADOR "APAGAR"

; Aquesta funci retorna totes les posicions on hi ha el
; valor que se li passa com a primer parmetre entre 2
; elements amb el mateix valor, independentment de la resta.
; Per exemple:
; (entre2 'X '(X X X X O O Y X X X L M M M X))
; retorna '(1 2 8)
; Les posicions comencen de 0.
; Per fer-ho utilitza les 3 funciona que hi ha a sota.

(defun entre2 (valor llista)
  (let ((grups (trobar_seguits valor llista)))
     (apply 'append
       (mapcar #'(lambda (x) (remove (car (last x)) (cdr x)))
               grups)
     )
  )
)

(defun trobar_seguits (valor llista)
   (let ((llocs (trobar_posicions valor llista 0))
         (seguits nil))
     (setq seguits (fer_grups (cdr (reverse llocs)) (last llocs) nil))
     (remove-if #'(lambda (x) (< (length x) 3)) seguits)
   )
) 

(defun trobar_posicions (valor llista num)
  (if (null llista) nil
    (if (equal valor (car llista)) 
       (cons num (trobar_posicions valor (cdr llista) (+ num 1)))
       (trobar_posicions valor (cdr llista) (+ num 1))
    )
  )
)

(defun fer_grups (llocs list-act list-total)
   (if (null llocs) (cons list-act list-total)
      (if (eq (car llocs) (- (car list-act) 1)) ;;numeros consecutius
         (fer_grups (cdr llocs) (cons (car llocs) list-act) list-total)
         (fer_grups (cdr llocs) (list (car llocs)) (cons list-act list-total))
      )
   )
)

;; --------------------------------------------------------

; IMPLEMENTACI DE L'ALGORISME A*

(defun A* (estat_inicial solucio)
    ;; Obrim un fitxer de LOG per guardar-hi el que va passant a cada pas
    (setq fit (open "llums.log" :direction :output :if-does-not-exist :create))
    
    ;; Crida a una funcio auxiliar recursiva que fa A*
    (A*aux (list(list 0 estat_inicial)) 1 solucio)  ;; fem una llista de camins
                                                    ;; amb 1 cam que comena a
                                                    ;; l'estat inicial

    ;; Tanquem el fitxer
    (close fit)
)

(defun A*aux (l-cami num solucio)

  (format fit "~% Pas ~a: llista camins actual" num) (print l-cami fit)  ;;log

  (if (null l-cami) (print "No hi ha solucio al problema")
    (let ((cami (car l-cami))
          (nou-lcami nil))
      (if (trobat_solucio cami solucio) ;; DETECTO L'ESTAT FINAL 
         (print cami)
         (progn ;; CONTINUO BUSCANT
           (setq nou-lcami (append (cdr l-cami) (print(successorsA* cami solucio))))
           (setq nou-lcami (ordenar nou-lcami '>))
           (setq nou-lcami (treure_redundants nou-lcami))
           (setq nou-lcami (ordenar nou-lcami '<))
           (A*aux nou-lcami (+ num 1) solucio)
         )
      )
    )
  )
)


; La llista de camins conte subllistes on hi ha el cost acumulat i a continuacio
; els estats que formen el cami. Ex. '(15 E3 E2 Eini)
; En aquesta funci es suma el valor de l'heurstica i el cost d'aplicacio
; de l'operador 1 per encendre i 2 per apagar.


(defun successorsA* (cami solucio)
  (let ((fill1 (encendre (copy-list (cadr cami))))
        (fill2 (apagar (copy-list (cadr cami))))
        (resultat nil)
       )

    (if (and (null fill1) (null fill2)) nil ;no hi ha successors
      (progn
        (if (and (not(null fill1)) (not(member fill1 cami :test 'equal)))
              ;; tenim fill1 i no ens porta a un estat repetit
              (progn
                (print "aplico operador1: encendre" fit) 
                (setq resultat (list (cons (+ (car cami) 1 
                                              (heuristica fill1 solucio)) 
                                           (cons fill1 (cdr cami)))))
              )
        )
        (if (and (not(null fill2)) (not(member fill2 cami :test 'equal)))
              ;;tenim fill2 i no ens porta a un estat repetit
              (progn
                (print "aplico operador2: apagar" fit)
                (setq resultat 
                   (cons (cons (+ (car cami) 2 
                                        (heuristica fill2 solucio)) 
                                     (cons fill2 (cdr cami)))
                          resultat))
              )
        )
        resultat
      )
    )
  )
)

;; cami sera una llista del tipus '(valor estat) 
;; i solucio sera un estat, el final.

(defun trobat_solucio (cami solucio)
  (equal (cadr cami) solucio)
)

;; Funcions auxiliars per l'algorisme A*

(defun ordenar (lcami mode)
   (sort lcami #'(lambda (x y) (funcall mode (car x) (car y))))
)


(defun treure_redundants (lcami)
   (if (null lcami) nil
      (let ((cami (car lcami)))
        (if (member (cadr cami) (mapcar 'cadr (cdr lcami))
                    :test 'equal) ;;node repetit
           (treure_redundants (cdr lcami))
           (cons cami (treure_redundants (cdr lcami)))
        )
      )
   )
)

